// I_to_DS_n_aux().
// General includes.
#include "cl_sysdep.h"

// Specification.
#include "cl_I_log.h"


// Implementation.

#include "cl_number.h"
#include "cl_I.h"
#include "cl_DS.h"

uintD* I_to_DS_n_aux (const cl_I& obj, uintC n, uintD* destptr)
    { // Nun sind unterhalb von destptr n Digits Platz.
      // oberen Teil der DS aus obj fllen, dabei destptr erniedrigen:
      if (fixnump(obj))
        // Fixnum:
        { var uint32 wert = FN_to_L(obj);
          #define FN_maxlength_a  (intLsize/intDsize)
          #define FN_maxlength_b  (FN_maxlength<=FN_maxlength_a ? FN_maxlength : FN_maxlength_a)
          // FN_maxlength Digits ablegen. Davon kann man FN_maxlength_b Digits aus wert nehmen.
          #if (FN_maxlength_b > 1)
          doconsttimes(FN_maxlength_b-1,
            *--destptr = (uintD)wert; wert = wert >> intDsize;
            );
          #endif
          *--destptr = (uintD)wert;
          #if (FN_maxlength > FN_maxlength_b)
          // Es ist oint_data_len = intLsize, brauche
          // noch FN_maxlength-FN_maxlength_b = 1 Digit.
          *--destptr = (sintD)R_sign(obj);
          #endif
          n -= FN_maxlength;
        }
        else
        // Bignum:
        { var uintC len = TheBignum(obj)->length;
          // Pointer bestimmen:
          var uintD* ptr = &TheBignum(obj)->data[(uintP)len];
          n -= len;
          destptr = copy_loop_down(ptr,destptr,len); // DS kopieren
        }
      // unteren Teil mit Flldigits, gebildet aus dem Vorzeichen, fllen:
      if (!(n==0))
        { destptr = fill_loop_down(destptr,n,sign_of_sintD(destptr[0])); }
      // destptr zeigt nun aufs untere Ende der DS.
      return destptr;
    }
